<script lang="ts">
    import Dialog, { Actions, Content, Header, Title } from "@smui/dialog";
    import IconButton from "@smui/icon-button";
    import Button from "@smui/button";
    import OptionsList from "./OptionsList.svelte";
    import type { SearchOption } from "$lib/stores/searchConfig.store";
    import BaseChip from "./BaseChip.svelte";

    interface SearchOptionChipConfig {
        key: number;
        name: string;
        placeholder: string;
        type: string;
        icon?: string;
        update: (value?: string) => void;
    }

    export let chip: SearchOptionChipConfig;
    export let options: SearchOptionChipConfig[];
    export let optionValues: SearchOption[];
    export let active: boolean;

    let open = false;
    let displayOptions: any[] = []; //TODO:set type

    function closeHandler(e: CustomEvent<{ action: string }>) {
        switch (e.detail.action) {
            case "done":
                for (let displayOption of displayOptions) {
                    displayOption.update(displayOption.value);
                }
                break;
            case "cancel":
            default:
                break;
        }
    }
</script>

<Dialog
    bind:open
    fullscreen
    aria-labelledby="fullscreen-title"
    aria-describedby="fullscreen-content"
    on:SMUIDialog:closed={closeHandler}
>
    <Header>
        <Title id="fullscreen-title">More Options</Title>
        <IconButton action="close" class="material-icons">close</IconButton>
    </Header>
    <Content id="fullscreen-content">
        <OptionsList options={displayOptions} />
    </Content>
    <Actions>
        <Button action="cancel">Cancel</Button>
        <Button action="done">Done</Button>
    </Actions>
</Dialog>

<BaseChip
    {chip}
    {active}
    value=""
    actionCallback={() => {
        displayOptions = options.map((option) => ({
            ...option,
            value:
                optionValues.find(
                    (optionValue) => optionValue.name === option.name
                )?.value ?? "",
        }));
        open = true;
    }}
/>
